*Adapted from the [example_governance.md](https://github.com/openmainframeproject/tac/blob/master/process/example_governance.md) recommendation from Open Mainframe Project TAC*

# Overview

This project aims to be governed in a transparent, accessible way for the benefit of the community. All participation in this project is open and not bound to corporate affiliation. Participants are bound to the project's [Code of Conduct](CODE_OF_CONDUCT.md).

# Project roles

## Contributor

The contributor role is the starting role for anyone participating in the project and wishing to contribute code.

### Process for becoming a contributor

* Review the [contribution guidelines](CONTRIBUTING.md) guidelines to ensure your contribution is in line with the project's coding and styling guidelines.
* Submit your code as a [pull request](https://github.com/openmainframeproject/cobol-programming-course/pulls) with the appropriate [DCO signoff](https://github.com/openmainframeproject/tac/blob/master/process/contribution_guidelines.md#developer-certificate-of-origin)
* Have your submission approved by the committer(s) and merged into the codebase.

## Committer

The committer role enables the contributor to commit code directly to the repository, but also comes with the responsibility of being a responsible leader in the community.

### Process for becoming a committer

* Show your experience with the codebase through contributions and engagement on the community channels.
* Request to become a committer.
* Have the majority of committers approve you becoming a committer.
* Your name and email are added to the [COMMITTERS.csv](COMMITTERS.csv) file for the project.

### Committer responsibilities

* Monitor and moderate the [mailing list](https://lists.openmainframeproject.org/g/cobol-course-discussion).
* Monitor [#cobol-programming-course Slack channel](https://slack.openmainframeproject.org) (delayed response is perfectly acceptable).
* Triage [GitHub issues](https://github.com/openmainframeproject/cobol-programming-course/issues) and perform [pull request reviews](https://github.com/openmainframeproject/cobol-programming-course/pulls) for other committers and the community.
* Make sure that ongoing PRs are moving forward at the right pace or closing them.

### When does a committer lose committer status

If a committer is no longer interested or cannot perform the committer duties listed above, they should volunteer to be moved to emeritus status. In extreme cases, this can also occur by a vote of the committers per the voting process below.

## Lead

The project committers will elect a lead ( and optionally a co-lead ) which will be the primary point of contact for the project and representative to the TAC upon becoming an Active stage project. The lead(s) will be responsible for the overall project health and direction, coordination of activities, and working with other projects and committees as needed for the continued growth of the project.

# Release Process

Project releases will occur on a scheduled basis as agreed to by the committers as defined in [RELEASE.md](RELEASE.md)

# Conflict resolution and voting

In general, we prefer that technical issues and committer membership are amicably worked out between the persons involved. If a dispute cannot be decided independently, the committers can be called in to decide an issue. If the committers themselves cannot decide an issue, the issue will be resolved by voting. The voting process is a simple majority in which each committer receives one vote.

# Communication

This project, just like all of open source, is a global community. In addition to the [Code of Conduct](CODE_OF_CONDUCT.md), this project will:

* Keep all communication on open channels ( mailing list, forums, chat ).
* Be respectful of time and language differences between community members ( such as scheduling meetings, email/issue responsiveness, etc ).
* Ensure tools are able to be used by community members regardless of their region.

If you have concerns about communication challenges for this project, please contact the committers.
