# Resources

These resources are provided for the benefit of the community. Neither this project nor Open Mainframe Project endorses any one of these particular resources.

### COBOL Programming Resources
- [COBOL Resource Hub on IBM Developer](https://developer.ibm.com/languages/cobol/)
- [COBOL Fridays Replay Videos](https://developer.ibm.com/series/cobol-fridays-webinar-videos/)
- YouTube Video: [So you want to learn COBOL?](https://youtu.be/77o14aHUuSo)
- [Beginner’s Guide: COBOL Made Easy](https://medium.com/modern-mainframe/beginners-guide-cobol-made-easy-introduction-ecf2f611ac76) by Jessielaine Punongbayan
- [IBM Enterprise COBOL for z/OS Documentation Library](https://www.ibm.com/support/pages/enterprise-cobol-zos-documentation-library) - Full Reference Library of COBOL Manuals
- [IBM Enterprise COBOL for z/OS v6.3: Language Reference](https://publibfp.boulder.ibm.com/epubs/pdf/igy6lr30.pdf)
- [IBM Enterprise COBOL for z/OS v6.3: Messages and Codes](https://publibfp.boulder.ibm.com/epubs/pdf/c2746481.pdf)
- [IBM Enterprise COBOL for z/OS v6.3: Programming Guide](https://publibfp.boulder.ibm.com/epubs/pdf/igy6pg30.pdf)

### Zowe Resources
- [Installing Zowe CLI](https://docs.zowe.org/stable/user-guide/cli-installcli/)
- [Installing Zowe Explorer](https://docs.zowe.org/stable/user-guide/ze-install)
- [Using Zowe CLI](https://docs.zowe.org/stable/user-guide/cli-usingcli/)
- [Using Zowe Explorer](https://docs.zowe.org/stable/user-guide/ze-usage)

### General z/OS Resources
- [z/OS Introduction - an IBM Redbooks Course](https://www.redbooks.ibm.com/redbooks.nsf/redbookabstracts/crse0304.html?Open)
- [IBM z/OS 2.4: Language Environment Programming Reference](https://www-01.ibm.com/servers/resourcelink/svc00100.nsf/pages/zosV2R4SA380683/$file/ceea300_v2r4.pdf)
- [IBM z/OS 2.4: MVS JCL Reference](https://www-01.ibm.com/servers/resourcelink/svc00100.nsf/pages/zOSV2R4sa231385/$file/ieab600_v2r4.pdf)
- [IBM z/OS 2.4: TSO/E REXX Reference](https://www-01.ibm.com/servers/resourcelink/svc00100.nsf/pages/zOSV2R4sa320972/$file/ikja300_v2r4.pdf)
- [IBM z/OS Communications Server 2.4: IP User's Guide and Commands](https://www-01.ibm.com/servers/resourcelink/svc00100.nsf/pages/zOSV2R4sc273662/$file/halu001_v2r4.pdf)
- [IBM Mainframe Operating Systems: Timeline and Brief Explanation](https://webfiles.uci.edu/scosel/_$OSTL37.5.pdf) by Dave Morton, February 2018.

### Additional Training & Hands-on Opportunities
- [z/OS Introduction and Workshop for IT Professionals](https://ibm.biz/zOSclass)
- [IBM Z Xplore](https://www.ibm.com/it-infrastructure/z/education/zxplore)

### DFSORT
IBM DFSORT's ICETOOL can often replace the need to write COBOL program(s), when needing to (optionally) sort and tranform data contained in one or more input files to produce an output file.  All user guides written by Frank L. Yaeger on this subject are excellent.
- [DFSORT: ICETOOL Mini-User Guide](https://www.ibm.com/support/pages/sites/default/files/inline-files/$FILE/sorttool.pdf) by Frank L. Yaeger, October 2010.
- [DFSORT′s Year 2000 Features (The New Generation)](https://www.ibm.com/support/pages/sites/default/files/inline-files/$FILE/sort2000.pdf) by Frank L. Yaeger, October 1998.
- [IBM z/OS 2.4: DFSORT Application Programming Guide](https://www-01.ibm.com/servers/resourcelink/svc00100.nsf/pages/zOSV2R4sc236878/$file/icea100_v2r4.pdf)

### Subsystems
- [Db2 12 for z/OS Documentation](https://www.ibm.com/support/pages/db2-12-zos-product-documentation)
- [Db2 SQL Cookbook](http://db2-sql-cookbook.org/)
- [CICS TS 5.6 for z/OS Documentation](https://www.ibm.com/docs/en/cics-ts/5.6?topic=available-documentation-in-pdf)
- [Introduction to CICS - an IBM Redbooks Course](https://www.redbooks.ibm.com/redbooks.nsf/redbookabstracts/crse0303.html?Open)

### Additional Resources
- [Visual Studio Code Documentation](https://code.visualstudio.com/docs)
- [IBM Z Open Editor Documentation](https://ibm.github.io/zopeneditor-about/Docs/introduction.html)
- [Code4z Documentation](https://techdocs.broadcom.com/us/en/ca-mainframe-software/devops/ca-brightside/3-0/code4z-vscode-extension-pack.html)
- [IBM Z and LinuxONE Community](https://www.ibm.com/community/z/)
- [Open Mainframe Project Website](https://www.openmainframeproject.org/)
- [IBM and Open Mainframe Project Mobilize to Connect States with COBOL Skills](https://newsroom.ibm.com/2020-04-09-IBM-and-Open-Mainframe-Project-Mobilize-to-Connect-States-with-COBOL-Skills)
- [Dr. David Woolbright's (COBOL Fridays: Presenter) Website](https://punctiliousprogrammer.com/)
- [Fake Your Way Through Minis and Mainframes - Including MVS (predecessor to z/OS)](http://www.snee.com/bob/opsys.html)
